/*
   memory.h - version 1.0, 2002

   cMemory is a class for storing computed values 
   identified by integers.

   Copyright (c) 2001-2002 Andreas Jnsson

   This software is provided 'as-is', without any form of
   warranty. In no case will the author be held responsible
   for any damage caused by its use.

   Permission is granted to anyone to use the software for
   for any purpose, including commercial. It is also allowed
   to modify the software and redistribute it free of charge.
   The permission is granted with the following restrictions:

   1. The origin of the software may not be misrepresented.
      It must be plainly understandable who is the author of
      the original software.
   2. Altered versions must not be misrepresented as the
      original software, i.e. must be plainly marked as
      altered.
   3. This notice may not be removed or altered from any
      distribution of the software, altered or not.

   Andreas Jnsson
   andreas@angelcode.com
*/


#ifndef MEMORY_H
#define MEMORY_H

// The templates used in this file results in extremely long 
// identifier names that gives multiple warnings but no errors.
// This can make it difficult to debug this part, but should 
// not result in any problems during execution.
#pragma warning( disable : 4503 4786 )

#include <map>
using namespace std;

typedef map<int,double> cMapIntToDouble;

class cMemory
{
public:
	cMemory();

	double Store(int id, double value);
	double Recall(int id);
	double Clear(int id);

protected:
	cMapIntToDouble memory;
};

#endif